#include<iostream>
#include<vector>
#include<queue>
#include<stack>
#include<math.h>
#include<algorithm>
#include<map>
#include<unordered_map>
#include<set>
using namespace std;

const int MAX_N=100100;
int v[MAX_N];
int g[MAX_N];
int n,k;
vector<vector<int> > groups;
vector<unordered_map<int, vector<int>> > gvg;

struct Player
{
    int id;
    int vg;
    int g;
};
Player p[MAX_N];
bool operator<(const Player& a, const Player& b)
{
    if (a.g!=b.g)
        return a.g<b.g;
    else
        return a.vg<b.vg;
}

void input()
{
    cin>>n>>k;
    int a,b;
    for (int i=0; i<k; ++i)
    {
        cin>>a;
        for (int j=0; j<a; ++j)
        {
            cin>>b;
            --b;
            g[b]=i;
        }
    }
    for (int i=0; i<n; ++i)
    {
        cin>>v[i];
        --v[i];
    }
}
int currg;
void output()
{
    cout<<groups.size()<<'\n';
    for (int i=0; i<groups.size(); ++i)
    {
        cout<<groups[i].size()<<' ';
        for (int j=0; j<groups[i].size(); ++j)
        {
            cout<<groups[i][j]+1<<' ';
        }
        cerr<<'\n';
    }
}
void solve()
{
    bool f;
    bool change=1;
    currg=k-1;
    while (change)
    {
        change=0;
        for (int i=0; i<n; ++i)
        {
            p[i].id=i;
            p[i].g=g[i];
            p[i].vg=g[v[i]];
        }
        sort(p,p+n);
        for (int i=0; i<n; ++i)
        {
            //cerr<<p[i].id<<" "<<p[i].g<<"  "<<v[p[i].id]<<" "<<p[i].vg<<endl;
            if (i==0 || p[i].g!=p[i-1].g)
            {
                f=0;
            }
            else
            {
                if (p[i].vg!=p[i-1].vg)
                {
                    change=1;
                    ++currg;
                    f=1;
                }
                if (f==1)
                {
                    g[p[i].id]=currg;
                }
            }
        }
    }
    int lg=-1;
    for (int i=0; i<n; ++i)
    {
        if (i==0 || p[i].g!=p[i-1].g)
        {
            ++lg;
            groups.push_back({});
        }
        groups[lg].push_back(p[i].id);
    }
}
queue<int> updated;
void solve2()
{
    bool f;
    bool ff;
    bool change=1;
    currg=k-1;
    int vg;
    gvg.resize(n);
    int cnt=0;
    while (change && cnt<2)
    {
        change=0;
        for (int i=0; i<currg; ++i)
        {
            gvg[i].clear();
        }
        for (int i=0; i<n; ++i)
        {
            gvg[g[i]][g[v[i]]].push_back(i);
        }
        for (int i=0; i<=currg; ++i)
        {
            auto& m=gvg[i];
            f=0;
            ff=0;
            for (auto j=m.begin(); j!=m.end(); ++j)
            {
                vg=j->first;
                //cerr<<"g: "<<i<<" vg: "<<vg<<endl;
                if (f==0)
                {
                    f=1;
                    continue;
                }
                /*if (ff==0)
                {
                    updated.push(i);
                }
                ff=1;*/
                change=1;
                ++currg;
                vector<int>& c=j->second;
                for (int k=0; k<c.size(); ++k)
                {
                    //cerr<<"g: "<<i<<" vg: "<<vg<<" id: "<<c[k]<<" ng: "<<currg<<endl;
                    g[c[k]]=currg;
                }
            }
        }
        //cerr<<endl;
        ++cnt;
    }
    for (int i=0; i<n; ++i)
    {
        p[i].id=i;
        p[i].g=g[i];
        p[i].vg=g[v[i]];
    }
    sort(p,p+n);
    int lg=-1;
    for (int i=0; i<n; ++i)
    {
        if (i==0 || p[i].g!=p[i-1].g)
        {
            ++lg;
            groups.push_back({});
        }
        groups[lg].push_back(p[i].id);
    }
}

int main()
{
    cin.tie(0);
    ios::sync_with_stdio(0);

    input();
    solve2();
    output();

    return 0;
}
