#include <bits/stdc++.h>
#define endl '\n'

//#pragma GCC optimize ("O3")
//#pragma GCC target ("sse4")

using namespace std;
template<class T, class T1> void chkmax(T &x, const T1 &y) { if(x < y) x = y; }
template<class T, class T1> void chkmin(T &x, const T1 &y) { if(x > y) x = y; }
const int MAXN = 117;

int n, m;
string t[MAXN];

void read()
{
    cin >> n >> m;
    for(int i = 0; i < n; i++)
        cin >> t[i];
}

bool ok()
{
    for(int i = 0; i < n; i++)
        for(int j = 0; j < m; j++)
            if(t[i][j] != 'X' && t[i][j] != '.')
                return false;

    return true;
}

int up[MAXN][MAXN], lft[MAXN][MAXN];
int up_ok[MAXN][MAXN], lft_ok[MAXN][MAXN];

pair<pair<int, int>, pair<int, int> > find_frame()
{
    for(int i = 0; i < n; i++)
        for(int j = 0; j < m; j++)
        {
            up_ok[i][j] = (t[i][j] != 'X') ? i : -1;
            lft_ok[i][j] = (t[i][j] != 'X') ? j : -1;
        }

    for(int i = 0; i < n; i++) lft[i][0] = -1;
    for(int j = 0; j < m; j++) up[0][j] = - 1;

    for(int i = 1; i < n; i++)
        for(int j = 1; j < m; j++)
        {
            lft[i][j] = j - 1;
            up[i][j] = i - 1;
            if(t[i][j - 1] == 'X' || t[i][j - 1] == '-') lft[i][j] = lft[i][j - 1];
            if(t[i - 1][j] == 'X' || t[i - 1][j] == '|') up[i][j] = up[i - 1][j];

            chkmax(lft_ok[i][j], lft_ok[i][j - 1]);
            chkmax(up_ok[i][j], up_ok[i - 1][j]);
        }

    for(int i = n - 1; i >= 1; i--)
        for(int j = m - 1; j >= 1; j--)
            if(t[i][j] == '3' || t[i][j] == 'X')
            {
                bool ok = 0;
                if(t[i][j] == '3') ok = 1;
                for(int l = 2; i - l >= 0 && j - l >= 0; l++)
                {
                    if(t[i - l][j] != 'X' || t[i][j - l] != 'X') ok = 1;

                    if(t[i - l][j - l] == 'X' || t[i - l][j - l] == '1')
                        if(t[i - l][j] == '2' || t[i - l][j] == 'X')
                            if(t[i][j - l] == '4' || t[i][j - l] == 'X')
                                if(up[i][j - l] <= i - l && lft[i - l][j] <= j - l)
                                    if(ok || up_ok[i][j - l] > i - l || lft_ok[i - l][j] > j - l || t[i - l][j - l] != 'X')
                                        return {{i - l, j - l}, {i, j}};

                    if(t[i - l][j] != 'X' && t[i - l][j] != '|') break;
                    if(t[i][j - l] != 'X' && t[i][j - l] != '-') break;
                }
            }

    return {{-1, -1}, {-1, -1}};
}

void solve()
{
    vector<pair<pair<int, int>, pair<int, int> > > answer;

    while(true)//!ok())
    {
        pair<pair<int, int>, pair<int, int> > x = find_frame();

        if(x.first.first == -1) break; //while(true) {}

        for(int i = x.first.first; i <= x.second.first; i++)
        {
            t[i][x.first.second] = 'X';
            t[i][x.second.second] = 'X';
        }

        for(int i = x.first.second; i <= x.second.second; i++)
        {
            t[x.first.first][i] = 'X';
            t[x.second.first][i] = 'X';
        }

        //cin.get();

        //for(int i = 0; i < n; i++)
        //{
         //   for(int j = 0; j < m; j++)
        //        cout << t[i][j];
        //    cout << endl;
        //}

//cin.get();

        //cout << x.first.first << " " << x.first.second << " " << x.second.first << " " << x.second.second << endl;
        //cout << flush;



        answer.push_back(x);
    }

    cout << answer.size() << endl;
    for(int i = answer.size() - 1; i >= 0; i--)
        cout << answer[i].first.first << " " << answer[i].first.second << " " << answer[i].second.first << " " << answer[i].second.second << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    read();
    solve();
    return 0;
}

/**
5 5
1--2.
|.1-2
|.|||
4-4-3
.....


10 10
..1-1----2
1-------2|
1----2--||
||||||..||
||||||..||
|-|-4|--|3
||||||--||
4----3--||
||4-----|3
4-------3.
**/
