#include<iostream>
#include<vector>
#include<set>
#include<map>
using namespace std;
const int MAXN=100005;
int group[MAXN];
int vote[MAXN];
int voter[MAXN];
int cntr[MAXN];
int groupVote[MAXN];
vector<int> groups[MAXN];
int cntGr;
vector<int> buckets[MAXN];
map<pair<int,int>,int> already;
int n;
set<int> toFix;
void fixGroup(int index){
	already.erase({cntr[groups[index][0]],groupVote[index]});
	set<int> goOver;
	for(int i=0;i<groups[index].size();i++){
		buckets[group[vote[groups[index][i]]]].push_back(groups[index][i]);
		goOver.insert(group[vote[groups[index][i]]]);
	}
	groups[index].clear();
	bool first=false;
	for(auto i:goOver){
		if(buckets[i].size()>0){
			if(already.find({cntr[buckets[i][0]],i})!=already.end()){
				int val=already[{cntr[buckets[i][0]],i}];
				for(int j=0;j<buckets[i].size();j++){
					groups[val].push_back(buckets[i][j]);		
					group[buckets[i][j]]=val;
					toFix.insert(group[voter[buckets[i][j]]]);
				}
				buckets[i].clear();
				continue;
			}
			if(!first){
				for(int j=0;j<buckets[i].size();j++){
					groups[index].push_back(buckets[i][j]);		
					group[buckets[i][j]]=index;
				}
				already[{cntr[buckets[i][0]],i}]=index;
				groupVote[index]=i;
				first=true;
			}else{
				for(int j=0;j<buckets[i].size();j++){
					groups[cntGr].push_back(buckets[i][j]);
					group[buckets[i][j]]=cntGr;
					toFix.insert(group[voter[buckets[i][j]]]);
				}
				already[{cntr[buckets[i][0]],i}]=cntGr;
				groupVote[cntGr]=i;
				cntGr++;
			}
			buckets[i].clear();
		}
	}
	if(!first){
		swap(groups[index],groups[cntGr-1]);
		cntGr--;
	}
}
int main(){
	cin.tie(NULL);
	ios::sync_with_stdio(false);
	int k,sz,a;
	cin>>n>>k;
	for(int i=0;i<k;i++){
		cin>>sz;
		for(int j=0;j<sz;j++){
			cin>>a;
			groups[i].push_back(a);
			group[a]=i;
			cntr[a]=i;
		}
		toFix.insert(i);
	}
	for(int i=0;i<n;i++){
		cin>>vote[i+1];
		voter[vote[i+1]]=i+1;
	}
	for(int i=0;i<k;i++){
		groupVote[i]=group[vote[groups[i][0]]];
		already[{i,groupVote[i]}]=i;
	}
	cntGr=k;
	while(toFix.size()!=0){
		int curr=(*toFix.begin());
		toFix.erase(*toFix.begin());
		fixGroup(curr);
	}
	/*queue<int> change;
	do{
		while(!change.empty()){
			int a=change.front();change.pop();
			int b=change.front();change.pop();
			if(a!=-1){
				groups[a].push_back(b);
				group[b]=group[groups[a][0]];
			}else{
				groups[cntGr].push_back(b);
				group[b]=cntGr++;
			}
		}
		for(int i=0;i<cntGr;i++){
			voter[i].clear();
		}
		for(int i=0;i<cntGr;i++){
			voter[group[vote[groups[i][0]]]].push_back(i);
		}
		cout<<cntGr<<"\n";
		for(int i=0;i<cntGr;i++){
			cout<<groups[i].size()<<" ";
			for(int j=0;j<groups[i].size();j++){
				cout<<groups[i][j]<<" ";
			}
			cout<<"\n";
		}
		/*cout<<cntGr<<"\n";
		for(int i=0;i<k;i++){
			for(int j=0;j<groups[i].size();j++){
				cout<<groups[i][j].size()<<" ";
				for(int p=0;p<groups[i][j].size();p++){
					cout<<groups[i][j][p]<<" ";
				}
				cout<<"\n";
			}
		}
		cout<<"\n";
		for(int i=0;i<cntGr;i++){
			for(int j=1;j<groups[i].size();j++){
				if(group[vote[groups[i][j]]]!=group[vote[groups[i][0]]]){
					int found=-1;
					for(int p=0;p<voter[group[vote[groups[i][j]]]].size();p++){
						int ind=voter[group[vote[groups[i][j]]]][p];
						if(cntr[groups[p][0]]==cntr[groups[i][j]]){
							change.push(ind);
							change.push(groups[i][j]);
							found=1;
						}
					}
					if(found==-1){
						change.push(-1);
						change.push(groups[i][j]);
					}
					swap(groups[i][j],groups[i].back());
					groups[i].pop_back();
					j--;
				}
			}
		}
	}while(!change.empty());*/
	cout<<cntGr<<"\n";
	for(int i=0;i<cntGr;i++){
		cout<<groups[i].size()<<" ";
		for(int j=0;j<groups[i].size();j++){
			cout<<groups[i][j]<<" ";
		}
		cout<<"\n";
	}
	return 0;
}
