#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;
int n, m;
pair < int, int > a[(1<<20)], b[(1<<20)];
vector < pair < int, int > > lh, uh;
long long ans = 0;

int opt[(1<<20)];
long long getS( pair < int, int > a, pair < int , int > b ) {
    if ( a.first >= b.first || a.second >= b.second ) { return 0 ;}
    return 1LL*( b.first-a.first)*(b.second-a.second);
}

void getOpt( int x, int l, int r ) {
    int maxInd = l;
    for ( int i = l ; i <= r ; i ++ ) {
        if ( getS( lh[x], uh[maxInd] ) < getS( lh[x], uh[i] ) ) {
            maxInd = i;
        }
    }
    opt[x] = maxInd;
}

void solve( int l, int r, int optL, int optR ) { /// [)  to []
    if ( l >= r ) { return; }

    int mid = (l+r)/2;
    getOpt( mid, optL, optR );
//    cout << mid << " : " << opt[mid] << "\n";

    solve( l, mid, optL, opt[mid] );
    solve( mid+1, r, opt[mid], optR );
}


int main () {
    cin >> n >> m;
    for ( int i = 0 ; i < n ; i ++ ) {
        cin >> a[i].first >> a[i].second;
        a[i].first *= -1;
    }

    for ( int i = 0 ; i < m ; i ++ ) {
        cin >> b[i].first >> b[i].second;
        b[i].first *= -1;
    }
    sort( a, a+n );
    reverse ( a, a+n );
    sort( b, b+m );

    for ( int i = 0 ; i < n ; i ++ ) {
        if ( lh.size() == 0 || lh.back().second > a[i].second ) {
            lh.push_back( a[i] );
        }
    }

    for ( int i = 0 ; i < m ; i ++ ) {
        if ( uh.size() == 0 || uh.back().second < b[i].second ) {
            uh.push_back( b[i] );
        }
    }

    for ( int i = 0 ; i < lh.size() ; i ++ ) {
        lh[i].first *= -1;
    }
    for ( int i = 0 ; i < uh.size() ; i ++ ) {
        uh[i].first *= -1;
    }

    reverse( uh.begin(), uh.end() );

    solve( 0, lh.size(), 0, (int)(uh.size())-1 );

    for ( int i = 0 ; i < lh.size() ; i ++ ) {
        ans = max( ans, getS( lh[i], uh[ opt[i] ] ) ) ;
    }
    cout << ans << "\n";
    return 0;
}
/*
3 4
4 5
5 3
2 8
9 6
8 8
0 0
4 10

*/
