#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;

long long to[(1<<20)], n, k;
long long par[(1<<20)], inDur[(1<<20)];
long long getP( long long x ) { return x == par[x] ? x : par[x] = getP( par[x] ); }

vector < long long > dur[(1<<20)];
vector < long long > cp;

vector < pair < int, long long > > hs[(1<<20)];

long long cntU[(1<<20)], base = 331, mod = 1000000009, pows[(1<<20)];
long long fl[(1<<20)];
long long cycLen[(1<<20)];
bool inCyc[(1<<20)];

vector < long long > in[(1<<20)];

long long cntGr = 0;
vector < long long > gr[(1<<20)];

void ss () {

    int ssHash ;

    long long d = cp.size();
    long long cHash = 0;

    for ( long long i = 0 ; i < d ; i ++ ) {
        cp[i] = getP( cp[i] );

        cHash *= base;

     //   cout << cp[i] << " ----- > " << inDur[cp[i]] << "\n";
        cHash += ( inDur[ cp[i] ] +1 );
        cHash %= mod;
    }
    ssHash = cHash;

    int per = cp.size();

    for ( long long s = 0 ; s < d ; s ++ ) {
        //hs[ inDur[ cp[s] ] ].push_back( make_pair( cHash, cp[s] ) );

     //   cout << s << " " << cp[s] << " : " << cHash << "\n";

        cHash = ( cHash - pows[ cp.size()-1 ]*( inDur[cp[s]]+1 )%mod + mod )*base%mod + inDur[ cp[s] ]+1;
        cHash %= mod;

        if ( cHash == ssHash ){
            per = s+1;
            break;
        }
    }

 //   cout << per << "\n";

    for ( int i = 0 ; i < per ; i ++ ) {
        for ( int j = 1 ; i + per*j < cp.size() ; j ++ ) {
            par[ cp [i+per*j] ] = cp[i];
        }
    }

    while( cp.size() > per ) { cp.pop_back(); }

    d = cp.size();
    cHash = 0;

    for ( long long i = 0 ; i < d ; i ++ ) {
        cp[i] = getP( cp[i] );

        cHash *= base;

     //   cout << cp[i] << " ----- > " << inDur[cp[i]] << "\n";
        cHash += ( inDur[ cp[i] ] +1 );
        cHash %= mod;
    }
    ssHash = cHash;

    for ( long long s = 0 ; s < d ; s ++ ) {
        hs[ inDur[ cp[s] ] ].push_back( make_pair( cHash, cp[s] ) );

     //   cout << s << " " << cp[s] << " : " << cHash << "\n";

        cHash = ( cHash - pows[ cp.size()-1 ]*( inDur[cp[s]]+1 )%mod + mod )*base%mod + inDur[ cp[s] ]+1;
        cHash %= mod;


    }


}

void mergeCyc ( long long i1, long long i2 ) {
   // cout << "merging " << i1 << " " << i2 << "\n";
    for ( int i = 0 ; i1 != i2 ; i ++ ) {
        i1 = to[i1];
        i1 = getP(i1);

        i2 = to[i2];
        i2 = getP(i2);

        par[i1] = i2;
    }
}


void mergeV( long long i1, long long i2 ) {
    long long p1 = getP(i1), p2 = getP(i2);

    if ( inDur[p1] != inDur[p2] ) { return; }
    if( p1 == p2 ) { return; }

//    cout << "merging " << i1 << " " << i2 << "\n";
    par[p2] = p1;

    for ( long long i = 0 ; i < in[p2].size() ; i ++ ) {
        in[p1].push_back( in[p2][i] );
        mergeV( in[p2][i], in[p1][0] );
    }

}

int main () {
    cin >> n >> k;
    for ( long long i = 0 ; i <= n ; i ++ ) { par[i] = i; }

    pows[0] = 1;
    pows[1] = base;
    for ( long long i = 2 ; i <= n ; i ++ ) { pows[i] = pows[i-1]*base%mod; }

    for ( long long i = 0 ; i < k ; i ++ ) {
        long long l;
        cin >> l;
        for ( long long j = 0 ; j < l ; j ++ ) {
            long long a;
            cin >> a;
            dur[i].push_back( a );
            inDur[a] = i;
        }
    }
    for ( long long i = 1 ; i <= n ; i ++ ) { cin >> to[i]; }

    for ( long long i = 1 ; i <= n ; i ++ ) {
        if ( cntU[i] ) { continue; }
        long long crr = i;
        for ( ; !cntU[crr];  crr = to[crr] ) {
            cp.push_back( crr );
            cntU[crr] = 1;
        }
        reverse( cp.begin(), cp.end() );
        for ( ; cp.size() && cp.back() != crr; cp.pop_back() );

      //  cout << "Cyc: \n";
      //  for ( long long i = 0 ; i < cp.size() ; i ++ ) {
      //      cout << cp[i] << " ";
     //   }
      //  cout << "\n";

        for ( long long i = 0 ; i < cp.size() ; i ++ ) {
            inCyc[ cp[i] ] = 1;
        }


        if ( cp.size() ) {
            ss();
        }
        cp.clear();
    }

    for ( long long h = 0 ; h < k ; h ++ ) {
        sort( hs[h].begin(), hs[h].end() ) ;
        for ( long long i = 0 ; i < hs[h].size() ; ) {

            long long j = i;
            for ( ; j < hs[h].size() && hs[h][i].first == hs[h][j].first ; j ++ ) {
                mergeCyc( hs[h][i].second, hs[h][j].second );
            }
            i = j;
        }
    }

    for ( long long i = 1 ; i <= n ; i ++ ) {
        in[ to[ getP(i) ] ].push_back( getP(i) ) ;
    }

    for ( int cc = 0 ; cc < n ; cc ++ ) {
        for ( long long i = 1 ; i <= n ; i ++ ) {
            for ( long long j = 0 ; j < in[i].size() ; j ++ ) {
           //     cout << " going to " << i << " :" << "merging " << in[i][j] << " " << in[i][0] << "\n";
                mergeV( in[i][j], in[i][0] );
            }
            //while ( in[i].size() > 1 ) { in[i].pop_back(); }
        }
    }

    for ( long long i = 1 ; i <= n ; i ++ ) {
        gr[ getP(i) ].push_back( i );
        if ( par[i] == i ) { cntGr ++; }
    }

    cout << cntGr << "\n";
    for ( long long i = 1 ; i <= n ; i ++ ) {
        if ( gr[i].size() ) {
            cout << gr[i].size() << " ";
            for ( long long j = 0 ; j < gr[i].size() ; j ++ ) {
                cout << gr[i][j] << " ";
            }
            cout << "\n";
        }
    }

    return 0;
}
/*
12 2
6 1 2 3 10 4 5
6 7 8 9 12 6 11
4 5 6 7 8 9 2 1 3 11 12 3

*/
