#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
using namespace std;

int to[(1<<20)], n, k;
int par[(1<<20)], inDur[(1<<20)];
int getP( int x ) { return x == par[x] ? x : par[x] = getP( par[x] ); }

vector < int > dur[(1<<20)];
vector < int > cp;

vector < pair < long long, int > > hs[(1<<20)];

long long cntU[(1<<20)], base = 331, mod = 1000000009, pows[(1<<20)];
int fl[(1<<20)];
int cycLen[(1<<20)];
bool inCyc[(1<<20)];

vector < int > in[(1<<20)];

int cntGr = 0;
vector < int > gr[(1<<20)];


vector < int > qq;

void ss () {

    long long ssHash ;

    int d = cp.size();
    long long cHash = 0;

    for ( int i = 0 ; i < d ; i ++ ) {
        cp[i] = getP( cp[i] );

        cHash *= base;

     //   cout << cp[i] << " ----- > " << inDur[cp[i]] << "\n";
        cHash += ( inDur[ cp[i] ] +1 );
        cHash %= mod;
    }
    ssHash = cHash;

    int per = cp.size();

    for ( int s = 0 ; s < d ; s ++ ) {
        //hs[ inDur[ cp[s] ] ].push_back( make_pair( cHash, cp[s] ) );

     //   cout << s << " " << cp[s] << " : " << cHash << "\n";

        cHash = ( cHash - pows[ cp.size()-1 ]*( inDur[cp[s]]+1 )%mod + mod )*base%mod + inDur[ cp[s] ]+1;
        cHash %= mod;

        if ( cHash == ssHash ){
            per = s+1;
            break;
        }
    }

 //   cout << per << "\n";

    for ( int i = 0 ; i < per ; i ++ ) {
        for ( int j = 1 ; i + per*j < cp.size() ; j ++ ) {
            par[ cp [i+per*j] ] = cp[i];
        }
    }

    while( cp.size() > per ) { cp.pop_back(); }

    d = cp.size();
    cHash = 0;

    for ( int i = 0 ; i < d ; i ++ ) {
        cp[i] = getP( cp[i] );

        cHash *= base;

     //   cout << cp[i] << " ----- > " << inDur[cp[i]] << "\n";
        cHash += ( inDur[ cp[i] ] +1 );
        cHash %= mod;
    }
    ssHash = cHash;

    for ( int s = 0 ; s < d ; s ++ ) {
        hs[ inDur[ cp[s] ] ].push_back( make_pair( cHash, cp[s] ) );

     //   cout << s << " " << cp[s] << " : " << cHash << "\n";

        cHash = ( cHash - pows[ cp.size()-1 ]*( inDur[cp[s]]+1 )%mod + mod )*base%mod + inDur[ cp[s] ]+1;
        cHash %= mod;


    }


}

void mergeCyc ( int i1, int i2 ) {
   // cout << "merging " << i1 << " " << i2 << "\n";
    for ( int i = 0 ; i1 != i2 ; i ++ ) {
        i1 = to[i1];
        i1 = getP(i1);

        i2 = to[i2];
        i2 = getP(i2);

        par[i1] = i2;
    }
}


bool mergeV( int i1, int i2 ) {
    int p1 = getP(i1), p2 = getP(i2);

    if ( inDur[p1] != inDur[p2] ) { return 0; }
    if( p1 == p2 ) { return 0; }

//    cout << "merging " << i1 << " " << i2 << "\n";
    par[p2] = p1;
    return 1;
}

bool cmp ( int a, int b ) {
    return inDur[a] < inDur[b];
}
set < int > act, nxt;
int main () {
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n >> k;
    for ( int i = 0 ; i <= n ; i ++ ) { par[i] = i; }

    pows[0] = 1;
    pows[1] = base;
    for ( int i = 2 ; i <= n ; i ++ ) { pows[i] = pows[i-1]*base%mod; }

    for ( int i = 0 ; i < k ; i ++ ) {
        int l;
        cin >> l;
        for ( int j = 0 ; j < l ; j ++ ) {
            int a;
            cin >> a;
            dur[i].push_back( a );
            inDur[a] = i;
        }
    }
    for ( int i = 1 ; i <= n ; i ++ ) { cin >> to[i]; }

    for ( int i = 1 ; i <= n ; i ++ ) {
        if ( cntU[i] ) { continue; }
        int crr = i;
        for ( ; !cntU[crr];  crr = to[crr] ) {
            cp.push_back( crr );
            cntU[crr] = 1;
        }
        reverse( cp.begin(), cp.end() );
        for ( ; cp.size() && cp.back() != crr; cp.pop_back() );

      //  cout << "Cyc: \n";
      //  for ( int i = 0 ; i < cp.size() ; i ++ ) {
      //      cout << cp[i] << " ";
     //   }
      //  cout << "\n";

        for ( int i = 0 ; i < cp.size() ; i ++ ) {
            inCyc[ cp[i] ] = 1;
        }


        if ( cp.size() ) {
            ss();
        }
        cp.clear();
    }

    for ( int h = 0 ; h < k ; h ++ ) {
        sort( hs[h].begin(), hs[h].end() ) ;
        for ( int i = 0 ; i < hs[h].size() ; ) {

            int j = i;
            for ( ; j < hs[h].size() && hs[h][i].first == hs[h][j].first ; j ++ ) {
                mergeCyc( hs[h][i].second, hs[h][j].second );
            }
            i = j;
        }
    }

    /*
    for ( int hh = 0 ; hh <= n ; hh ++ ) {
        for ( int k1 = 1 ; k1 <= n ; k1 ++ ) {
            for ( int k2 = 1 ; k2 <= n ; k2 ++ ) {
                if ( getP( to[k1] ) == getP( to[k2] ) ) { mergeV( k1, k2 ); }
            }
        }
    }
    */

    for ( int hh = 0 ; hh <= n ; hh ++ ) {
        for ( int i = 1 ; i <= n ; i ++ ) { in[i].clear(); }

        bool b = 0;

        for ( int i = 1 ; i <= n ; i ++ ) {
            in[ getP ( to[i] ) ].push_back( i ) ;
        }
        for ( int i = 1 ; i <= n ; i ++ ) {
            sort( in[i].begin(), in[i].end(), cmp );

            for ( int s = 0 ; s < in[i].size() ; ) {
           //     cout << "merging " << in[i][j] << " " << in[i][0] << "\n";
                int kkk = s;
                for ( ; kkk < in[i].size() && inDur[ in[i][s] ] == inDur[ in[i][kkk] ] ; kkk ++ )
                { b |= mergeV ( in[i][s], in[i][kkk] ); }

                s = kkk;
                //mergeV( in[i][0], in[i][j] );
            }
        }
        if ( b == 0 ) { break; }

    }

    /*
    for ( int i = 1 ; i <= n ; i ++ ) {

        for ( int j = 0 ; j < in[i].size() ; j ++ ) {
       //     cout << " going to " << i << " :" << "merging " << in[i][j] << " " << in[i][0] << "\n";
            mergeV( in[i][j], in[i][0] );
        }
        while ( in[i].size() > 1 ) { in[i].pop_back(); }

    }
    */

    for ( int i = 1 ; i <= n ; i ++ ) {
        gr[ getP(i) ].push_back( i );
        if ( par[i] == i ) { cntGr ++; }
    }

    cout << cntGr << "\n";
    for ( int i = 1 ; i <= n ; i ++ ) {
        if ( gr[i].size() ) {
            cout << gr[i].size() << " ";
            for ( int j = 0 ; j < gr[i].size() ; j ++ ) {
                cout << gr[i][j] << " ";
            }
            cout << "\n";
        }
    }

    return 0;
}
/*
12 2
6 1 2 3 10 4 5
6 7 8 9 12 6 11
4 5 6 7 8 9 2 1 3 11 12 3

*/
