# include <cstdio>
# include <vector>
# include <algorithm>

using namespace std;

const int MAX_N = 1e5 + 10;
const int MAX_K = 1e5 + 10;

int n, k;

vector <int> c[MAX_K];

int from[MAX_N];
int par[MAX_N];

int to[MAX_N];

bool in[MAX_N];

int u[MAX_N], key, stkey;

int find (int x)
{
    ///printf ("%d %d\n", x, par[x]);
    return (par[x] == x) ? x : par[x] = find (par[x]);
}

bool can_add (int x, int y)
{
    ///printf ("%d %d\n", x, y);
    if (rand () & 1)
        swap (x, y);

    int rx = find (x), ry = find (y);

    if (u[rx] == u[ry] && u[rx] >= stkey)
        return true;

    u[rx] = key;
    u[ry] = key;

    if (from[x] != from[y])
        return false;

    if (rx == ry)
        return true;

    key ++;
    if (can_add (to[rx], to[ry]))
    {
        par[rx] = ry;
        return true;
    }

    return false;
}

int main ()
{
    int i, j, t, p, q;

    scanf ("%d%d", &n, &k);

    for (i = 1; i <= k; i ++)
    {
        scanf ("%d", &p);
        c[i].resize (p);
        for (j = 0; j < p; j ++)
        {
            scanf ("%d", &c[i][j]);
            from[c[i][j]] = i;
        }
    }

    for (i = 1; i <= n; i ++)
    {
        scanf ("%d", &to[i]);
        par[i] = i;
    }

    vector <vector <int>> ans;

    for (t = 1; t <= k; t ++)
    {
        for (i = 0; i < c[t].size (); i ++)
        {
            if (in[c[t][i]])
                continue;

            vector <int> crr;

            in[c[t][i]] = true;
            crr.push_back (c[t][i]);

            for (j = i + 1; j < c[t].size (); j ++)
            {
                stkey ++;
                key = stkey;

                ///printf ("here %d %d\n", c[t][i], c[t][j]);

                if (can_add (c[t][i], c[t][j]))
                {
                    in[c[t][j]] = true;
                    crr.push_back (c[t][j]);
                }

                stkey = key;
            }

            ans.push_back (crr);
            crr.clear ();
        }
    }

    printf ("%d\n", (int) ans.size ());

    for (i = 0; i < (int) ans.size (); i ++)
    {
        printf ("%d", (int) ans[i].size ());
        for (j = 0; j < (int) ans[i].size (); j ++)
            printf (" %d", ans[i][j]);
        printf ("\n");
    }

    return 0;
}

/**
12 2
6 1 2 3 10 4 5
6 7 8 9 12 6 11
4 5 6 7 8 9 2 1 3 11 12 3
**/
