#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int32_t MAX_N = 105;
const int32_t MAX_M = 105;

class Rectangle {
public:
	int32_t x1, y1, x2, y2;

	Rectangle(int32_t x1 = 0, int32_t y1 = 0, int32_t x2 = 0, int32_t y2 = 0) : x1(x1), y1(y1), x2(x2), y2(y2) {
		
	}
};

char board[MAX_N][MAX_M];
int32_t n, m;
vector< Rectangle > rects;

void FindRect() {
	for(int32_t i = 1; i <= n; i++) {
		for(int32_t j = 1; j <= m; j++) {
			if(board[i][j] == '1') {
				for(int32_t p = i + 1; p <= n; p++) {
					if(board[p][j] == '4') {
						for(int32_t q = j + 1; q <= m; q++) {
							if((board[i][q] == '2' || board[i][q] == ' ') && (board[p][q] == '3' || board[p][q] == ' ')) {
								rects.push_back(Rectangle(i, j, p, q));
								for(int32_t i1 = i; i1 <= p; i1++) {
									for(int32_t j1 = j; j1 <= q; j1++) {
										board[i1][j] = ' ';
										board[i1][q] = ' ';
										board[i][j1] = ' ';
										board[p][j1] = ' ';
									}
								}
								
								return;
							}
							else if((board[p][q] != ' ' && board[p][q] != '-') || (board[i][q] != ' ' && board[i][q] != '-')) {
								break;
							}
						}
					}
					else if(board[p][j] != ' ' && board[p][j] != '|') {
						break;
					}
				}
			}
		}
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	cin >> n >> m;

	for(int32_t i = 1; i <= n; i++) {
		for(int32_t j = 1; j <= m; j++) {
			cin >> board[i][j];
		}
	}
	
	while(1) {
		int32_t cntRects = rects.size();
		FindRect();
		
		/**
		for(int32_t i = 1; i <= n; i++) {
			for(int32_t j = 1; j <= m; j++) {
				cout << board[i][j] << " ";
			}
			cout << endl;
		}
		*/

		if(cntRects == rects.size()) {
			break;
		}
	}
	
	reverse(rects.begin(), rects.end());
	
	cout << rects.size () << endl;
	for(auto r : rects) {
		cout << r.x1 - 1 << " " << r.y1 - 1 << " " << r.x2 - 1 << " " << r.y2 - 1 << endl;
	}
	return 0;
}
