#include <iostream>
#include <cstdio>
#include <algorithm>
using namespace std;

const int N=(1e5)+5;
const int LIMIT=2000;

struct Point
{
 long long x;
 long long y;
};

Point a[N],b[N];

long long GetArea(int i,int j)
{
  if(a[i].x>=b[j].x || a[i].y>=b[j].y)
   return 0;

 return (b[j].x-a[i].x)*(b[j].y-a[i].y);
}

bool CompareX1(Point p,Point q)
{
 return p.x<q.x;
}

bool CompareX2(Point p,Point q)
{
 return p.x>q.x;
}

bool CompareY1(Point p,Point q)
{
 return p.y<q.y;
}

bool CompareY2(Point p,Point q)
{
 return p.y>q.y;
}

int main()
{

int n,m,i,j,l1,l2;
long long ans;

scanf("%d%d",&n,&m);

 for(i=1;i<=n;i++)
  scanf("%lld%lld",&a[i].x,&a[i].y);

 for(i=1;i<=m;i++)
  scanf("%lld%lld",&b[i].x,&b[i].y);

 if(n<=LIMIT && m<=LIMIT)
 {
  ans=0;
   for(i=1;i<=n;i++)
    for(j=1;j<=m;j++)
     ans=max(ans,GetArea(i,j));

  printf("%lld\n",ans);
  return 0;
 }

l1=min(n,LIMIT);
l2=min(m,LIMIT);

sort(a+1,a+n+1,CompareX1);
sort(b+1,b+m+1,CompareX2);

ans=0;
 for(i=1;i<=l1;i++)
  for(j=1;j<=l2;j++)
   ans=max(ans,GetArea(i,j));

sort(b+1,b+m+1,CompareY2);

 for(i=1;i<=l1;i++)
  for(j=1;j<=l2;j++)
   ans=max(ans,GetArea(i,j));

sort(a+1,a+n+1,CompareY1);

 for(i=1;i<=l1;i++)
  for(j=1;j<=l2;j++)
   ans=max(ans,GetArea(i,j));

sort(b+1,b+m+1,CompareX2);

 for(i=1;i<=l1;i++)
  for(j=1;j<=l2;j++)
   ans=max(ans,GetArea(i,j));

printf("%lld\n",ans);

return 0;
}
