#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cstdlib>
#include <ctime>
using namespace std;

const int N=(1e5)+5;
const int LIMIT=2000;
const int L=2000;

struct Point
{
 long long x;
 long long y;
};

Point a[N],b[N];

long long GetArea(int i,int j)
{
  if(a[i].x>=b[j].x || a[i].y>=b[j].y)
   return 0;

 return (b[j].x-a[i].x)*(b[j].y-a[i].y);
}

bool TimeIsOK()
{
 return clock()/(double)CLOCKS_PER_SEC<0.18;
}

int main()
{

int n,m,i,j,l1,l2;
long long ans;

scanf("%d%d",&n,&m);

 for(i=1;i<=n;i++)
  scanf("%lld%lld",&a[i].x,&a[i].y);

 for(i=1;i<=m;i++)
  scanf("%lld%lld",&b[i].x,&b[i].y);

 if(n<=LIMIT && m<=LIMIT)
 {
  ans=0;
   for(i=1;i<=n;i++)
    for(j=1;j<=m;j++)
     ans=max(ans,GetArea(i,j));

  printf("%lld\n",ans);
  return 0;
 }

ans=0;
 while(TimeIsOK())
 {
  random_shuffle(a+1,a+n+1);
  random_shuffle(b+1,b+m+1);
  ans=max(ans,GetArea(1,1));
 }

printf("%lld\n",ans);

return 0;
}
