#include<iostream>
#include<vector>
#include<queue>
#include<stack>
#include<math.h>
#include<algorithm>
#include<map>
#include<set>
using namespace std;

const int MAX_N=100100;
int n,m;
struct Point
{
    long long x,y;
};
Point bl[MAX_N],ur[MAX_N];
long long ans=0;
bool operator<(const Point& a, const Point& b)
{
    if (a.x!=b.x) return a.x<b.x;
    return a.y<b.y;
}

void input()
{
    cin>>n>>m;
    for (int i=0;i<n;++i)
    {
        cin>>bl[i].x>>bl[i].y;
    }
    for (int i=0;i<m;++i)
    {
        cin>>ur[i].x>>ur[i].y;
    }
}
void output()
{
    cout<<ans<<'\n';
}
vector<Point> bl2,ur2;
const int MAX_ERR=10;
void solve()
{
    sort(bl,bl+n);
    sort(ur,ur+m);
    int maxy=-1,miny=-1;
    for (int i=0;i<n;++i)
    {
        if (miny==-1 || bl[i].y<miny)
        {
            bl2.push_back(bl[i]);
            miny=bl[i].y;
        }
    }
    for (int i=0;i<bl2.size()/2;++i)
    {
        swap(bl2[i],bl2[bl2.size()-1-i]);
    }
    for (int i=m-1;i>=0;--i)
    {
        if (maxy==-1 || ur[i].y>maxy)
        {
            ur2.push_back(ur[i]);
            maxy=ur[i].y;
        }
    }

    /*cerr<<endl;
    for (int i=0;i<bl2.size();++i)
    {
        cerr<<bl2[i].x<<" "<<bl2[i].y<<endl;
    }

    cerr<<endl;
    for (int i=0;i<ur2.size();++i)
    {
        cerr<<ur2[i].x<<" "<<ur2[i].y<<endl;
    }*/

    int curr=0;
    long long cans;
    long long ccans;
    long long prans;
    //cerr<<endl;
    int errc;
    for (int i=0;i<bl2.size();++i)
    {
        while (curr<ur2.size() && ur2[curr].y<=bl2[i].y) ++curr;
        //cerr<<i<<" "<<curr<<endl;
        if (curr==ur2.size()) break;
        cans=-1;
        prans=-1;
        errc=0;
        for (int j=curr;j<ur2.size();++j)
        {
            if (ur2[j].x<=bl2[i].x) break;
            ccans=(ur2[j].x-bl2[i].x)*(ur2[j].y-bl2[i].y);
            //cerr<<" "<<i<<" "<<j<<" "<<ccans<<endl;
            if (cans==-1 || ccans>=cans)
            {
                cans=ccans;
                curr=j;
                errc=0;
            }
            else if (ccans<prans) ++errc;
            else errc=0;
            if (errc>MAX_ERR) break;
            prans=ccans;
        }
        if (cans>ans) ans=cans;
    }
}

int main()
{
    cin.tie(0);
    ios::sync_with_stdio(0);

    input();
    solve();
    output();

    return 0;
}
