#include<iostream>
#include<vector>
#include<queue>
#include<stack>
#include<math.h>
#include<algorithm>
#include<map>
#include<unordered_map>
#include<set>
#include<stdlib.h>
using namespace std;

const int MAX_N=100100;
int v[MAX_N];
int g[MAX_N];
int gsize[MAX_N];
int rg[MAX_N];
int n,k;
vector<vector<int> > groups;
vector<unordered_map<int, vector<int>> > gvg;
vector<int> gg[MAX_N];

struct Player
{
    int id;
    int vg;
    int g;
};
Player p[MAX_N];
bool operator<(const Player& a, const Player& b)
{
    if (a.g!=b.g)
        return a.g<b.g;
    else
        return a.vg<b.vg;
}

void input()
{
    cin>>n>>k;
    int a,b;
    for (int i=0; i<k; ++i)
    {
        cin>>a;
        for (int j=0; j<a; ++j)
        {
            cin>>b;
            --b;
            g[b]=i;
        }
    }
    for (int i=0; i<n; ++i)
    {
        cin>>v[i];
        --v[i];
    }
}
int currg;
void output()
{
    cout<<groups.size()<<'\n';
    for (int i=0; i<groups.size(); ++i)
    {
        cout<<groups[i].size()<<' ';
        for (int j=0; j<groups[i].size(); ++j)
        {
            cout<<groups[i][j]+1<<' ';
        }
        cerr<<'\n';
    }
}/*
void solve()
{
    bool f;
    bool change=1;
    currg=k-1;
    while (change)
    {
        change=0;
        for (int i=0; i<n; ++i)
        {
            p[i].id=i;
            p[i].g=g[i];
            p[i].vg=g[v[i]];
        }
        sort(p,p+n);
        for (int i=0; i<n; ++i)
        {
            //cerr<<p[i].id<<" "<<p[i].g<<"  "<<v[p[i].id]<<" "<<p[i].vg<<endl;
            if (i==0 || p[i].g!=p[i-1].g)
            {
                f=0;
            }
            else
            {
                if (p[i].vg!=p[i-1].vg)
                {
                    change=1;
                    ++currg;
                    f=1;
                }
                if (f==1)
                {
                    g[p[i].id]=currg;
                }
            }
        }
    }
    int lg=-1;
    for (int i=0; i<n; ++i)
    {
        if (i==0 || p[i].g!=p[i-1].g)
        {
            ++lg;
            groups.push_back({});
        }
        groups[lg].push_back(p[i].id);
    }
}*/
int findUF(int a)
{
    if (rg[a]==a)
        return a;
    return rg[a]=findUF(rg[a]);
}
bool checkUF(int a, int b)
{
    a=findUF(a);
    b=findUF(b);
    return !(a==b);
}
int unions;
void uniteUF(int a, int b)
{
    a=findUF(a);
    b=findUF(b);
    if (a==b)
        return;
    --unions;
    if (gsize[a]>gsize[b])
    {
        rg[b]=a;
        gsize[a]+=gsize[b];
    }
    else
    {
        rg[a]=b;
        gsize[b]+=gsize[a];
    }
}
long long vis[MAX_N];
long long currcheck=1;
void uniteAll(int a, int b)
{
    if (vis[a]==currcheck && vis[b]==currcheck)
        return;
    vis[a]=currcheck;
    vis[b]=currcheck;
    uniteUF(a,b);
    uniteAll(v[a],v[b]);
}
bool checkValid(int a, int b)
{
    if (vis[a]==currcheck && vis[b]==currcheck)
        return 1;
    if (g[a]!=g[b])
        return 0;
    vis[a]=currcheck;
    vis[b]=currcheck;
    return checkValid(v[a],v[b]);
}
//time_t curr,start;
void finishSolve()
{
    for (int i=0; i<n; ++i)
    {
        rg[i]=i;
        gsize[i]=1;
    }
    int a,b,cg;
    /*for (int i=0; i<=currg; ++i)
    {
        auto& m=gvg[i];
        for (auto j=m.begin(); j!=m.end(); ++j)
        {
            vector<int>& c=j->second;
            for (int k=0; k<c.size(); ++k)
            {
                for (int k2=k+1; k2<c.size(); ++k2)
                {
                    a=c[k];
                    b=c[k2];
                    if (checkUF(a,b))
                    {
                        if (checkValid(a,b))
                        {
                            ++currcheck;
                            uniteAll(a,b);
                        }
                        ++currcheck;
                    }
                }
            }
        }
    }*/
    int cnt=0;
    unions=n;
    //curr=clock();
    for (int ll=0;ll<1000000;++ll)
    {
        cg=rand()%(currg+1);
        vector<int>& c=gg[cg];
        a=rand()%(c.size());
        do
        {
            b=rand()%(c.size());
        }
        while (b==a);
        a=c[a];
        b=c[b];
        if (checkUF(a,b))
        {
            if (checkValid(a,b))
            {
                ++currcheck;
                uniteAll(a,b);
            }
            ++currcheck;
        }
        //++cnt;
        //curr=clock();
        //cerr<<(curr-start)*1.0/CLOCKS_PER_SEC<<endl;
    }
    //cerr<<cnt<<" "<<unions<<endl;
}
void solve2()
{
    bool f;
    bool ff;
    bool change=1;
    currg=k-1;
    int vg;
    gvg.resize(n);
    int cnt=0;
    while (change && cnt<10)
    {
        change=0;
        for (int i=0; i<currg; ++i)
        {
            gvg[i].clear();
        }
        for (int i=0; i<n; ++i)
        {
            gvg[g[i]][g[v[i]]].push_back(i);
        }
        for (int i=0; i<=currg; ++i)
        {
            auto& m=gvg[i];
            f=0;
            ff=0;
            for (auto j=m.begin(); j!=m.end(); ++j)
            {
                vg=j->first;
                //cerr<<"g: "<<i<<" vg: "<<vg<<endl;
                if (f==0)
                {
                    f=1;
                    continue;
                }
                /*if (ff==0)
                {
                    updated.push(i);
                }
                ff=1;*/
                change=1;
                ++currg;
                vector<int>& c=j->second;
                for (int k=0; k<c.size(); ++k)
                {
                    //cerr<<"g: "<<i<<" vg: "<<vg<<" id: "<<c[k]<<" ng: "<<currg<<endl;
                    g[c[k]]=currg;
                }
            }
        }
        //cerr<<endl;
        ++cnt;
    }

    /*for (int i=0; i<currg; ++i)
    {
        gvg[i].clear();
    }
    for (int i=0; i<n; ++i)
    {
        gvg[g[i]][g[v[i]]].push_back(i);
    }*/

    for (int i=0; i<n; ++i)
    {
        gg[g[i]].push_back(i);
    }

    finishSolve();

    for (int i=0; i<n; ++i)
    {
        p[i].id=i;
        p[i].g=rg[i];
    }
    sort(p,p+n);
    int lg=-1;
    for (int i=0; i<n; ++i)
    {
        if (i==0 || p[i].g!=p[i-1].g)
        {
            ++lg;
            groups.push_back({});
        }
        groups[lg].push_back(p[i].id);
    }
}

int main()
{
    //start=clock();
    srand(0);
    cin.tie(0);
    ios::sync_with_stdio(0);

    input();
    //start=clock();
    solve2();
    output();

    return 0;
}
