#include <bits/stdc++.h>
#define endl '\n'

#pragma GCC optimize ("O3")
#pragma GCC target ("sse4")

using namespace std;
template<class T, class T1> void chkmax(T &x, const T1 &y) { if(x < y) x = y; }
template<class T, class T1> void chkmin(T &x, const T1 &y) { if(x > y) x = y; }
const int MAXN = (1 << 20);

int n, m;
pair<int, int> a[MAXN], b[MAXN];

void read()
{
    cin >> n >> m;
    for(int i = 0; i < n; i++)
        cin >> a[i].first >> a[i].second;
    for(int i = 0; i < m; i++)
        cin >> b[i].first >> b[i].second;
}

int64_t answer = 0;
vector<pair<int, int> > up, down;

int64_t area(int u, int d)
{
    return (down[d].second - up[u].second) * 1ll * (down[d].first - up[u].first);
}

void rec(int l1, int r1, int l2, int r2)
{
    if(l1 > r1) return;

    int mid = (l1 + r1) >> 1;

    int opt = l2;
    int64_t answer_opt = area(mid, l2);
    chkmax(answer, answer_opt);

    for(int i = max(0, l2 - 100); i <= min((int)down.size() - 1, r2 + 100); i++)
    {
        int64_t curr = area(mid, i);
        chkmax(answer, curr);

        if(curr > answer_opt)
            answer_opt = curr, opt = i;
    }

    rec(l1, mid - 1, l2, opt);
    rec(mid + 1, r1, opt, r2);
}

void solve()
{
    sort(a, a + n);
    sort(b, b + m);

    for(int i = 0; i < n; i++)
        if(up.empty() || (a[i].first != up.back().first && a[i].second < up.back().second))
            up.push_back(a[i]);

    for(int i = m - 1; i >= 0; i--)
        if(down.empty() || (b[i].first != down.back().first && b[i].second > down.back().second))
            down.push_back(b[i]);

    rec(0, up.size() - 1, 0, down.size() - 1);

    cout << answer << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    read();
    solve();
    return 0;
}

/**

3 4
4 5
5 3
2 8
9 6
8 8
0 0
4 10
**/
