#include <bits/stdc++.h>
#define endl '\n'

#pragma GCC optimize ("O3")
#pragma GCC target ("sse4")

using namespace std;
template<class T, class T1> void chkmax(T &x, const T1 &y) { if(x < y) x = y; }
template<class T, class T1> void chkmin(T &x, const T1 &y) { if(x > y) x = y; }
const int MAXN = (int)1e5 + 42 + 17;

int n, k;
vector<int> li[MAXN];
int nxt[MAXN];

int to[MAXN][41];
int gr[MAXN];

void read()
{
    cin >> n >> k;
    for(int i = 0; i < k; i++)
    {
        int c = 0;
        cin >> c;
        while(c--)
        {
            int x;
            cin >> x;
            gr[x] = x;
            li[i].push_back(x);
        }
    }

    for(int i = 1; i <= n; i++)
        cin >> nxt[i];
}

bool cmp(int x, int y) { return gr[to[x][40]] < gr[to[y][40]]; }

void solve()
{
    for(int i = 1; i <= n; i++)
        to[i][0] = nxt[i];

    for(int l = 1; l <= 40; l++)
        for(int i = 1; i <= n; i++)
            to[i][l] = to[to[i][l - 1]][l - 1];

    vector<vector<int> > answer;
    for(int i = 0; i < k; i++)
    {
        sort(li[i].begin(), li[i].end(), cmp);

        vector<int> curr;
        int last = -1;
        for(int x: li[i])
        {
            if(gr[to[x][40]] != last)
            {
                if(!curr.empty()) answer.push_back(curr);
                curr.clear();
            }

            curr.push_back(x);
            last = gr[to[x][40]];
        }

        answer.push_back(curr);
    }

    cout << answer.size() << endl;
    for(auto it: answer)
    {
        cout << it.size() << " ";
        for(int x: it) cout << x << " ";
        cout << endl;
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    read();
    solve();
    return 0;
}

/**
12 2
6 1 2 3 10 4 5
6 7 8 9 12 6 11
4 5 6 7 8 9 2 1 3 11 12 3

**/
