#include <bits/stdc++.h>
#define endl '\n'

//#pragma GCC optimize ("O3")
//#pragma GCC target ("sse4")

using namespace std;
template<class T, class T1> void chkmax(T &x, const T1 &y) { if(x < y) x = y; }
template<class T, class T1> void chkmin(T &x, const T1 &y) { if(x > y) x = y; }
const int MAXN = (int)1e5 + 42 + 17;
const uint64_t base = 1e6 + 7;

int n, k;
vector<int> li[MAXN];
int nxt[MAXN];

int to[MAXN][41];
uint64_t hsh[MAXN][41];
uint64_t base_pw2[41];
int gr[MAXN];
int tmp[base + 1];

void read()
{
    cin >> n >> k;
    for(int i = 0; i < k; i++)
    {
        int c = 0;
        cin >> c;
        while(c--)
        {
            int x;
            cin >> x;
            gr[x] = i + 1;
            li[i].push_back(x);
        }
    }

    for(int i = 1; i < base; i++)
        tmp[i] = i;
    random_shuffle(tmp + 1, tmp + base);

    for(int i = 1; i <= n; i++)
        gr[i] = tmp[gr[i]];

    for(int i = 1; i <= n; i++)
        cin >> nxt[i];
}

vector<vector<int> > answer;
vector<int> adj[MAXN];

uint64_t V[MAXN];

bool fcmp(int i, int j) { return make_pair(V[i], gr[i]) < make_pair(V[j], gr[j]); }

bool cmp2(int i, int j) { return V[i] < V[j]; }

vector<int> cmp;
bool used[MAXN];

void dfs(int u)
{
    used[u] = true;
    cmp.push_back(u);
    for(int v: adj[u])
        if(!used[v])
            dfs(v);
}

void solve()
{
    base_pw2[0] = 1;
    for(int i = 1; i <= 35; i++)
        base_pw2[i] = base_pw2[i - 1] * base;

    for(int i = 1; i <= n; i++)
        hsh[i][0] = gr[i], to[i][0] = nxt[i];

    for(int l = 1; l <= 35; l++)
        for(int i = 1; i <= n; i++)
        {
            hsh[i][l] = base_pw2[l - 1] * hsh[i][l - 1] + hsh[to[i][l - 1]][l - 1];
            to[i][l] = to[to[i][l - 1]][l - 1];
        }

    for(int i = 1; i <= n; i++)
    {
        V[i] = hsh[i][35];
        //cout << i << " -> " << V[i] << endl;
    }

    for(int i = 0; i < k; i++)
    {
        sort(li[i].begin(), li[i].end(), cmp2);

        vector<int> curr;
        uint64_t last = -1;
        for(int x: li[i])
        {
            if(V[x] != last)
            {
                if(!curr.empty()) answer.push_back(curr);
                curr.clear();
            }

            curr.push_back(x);
            last = V[x];
        }

        answer.push_back(curr);
    }

    /*
    for(int i = 1; i <= n; i++)
    {
        adj[i].push_back(nxt[i]);
        adj[nxt[i]].push_back(i);
    }

    for(int i = 1; i <= n; i++)
        if(!used[i])
        {
            cmp.clear();
            dfs(i);

            sort(cmp.begin(), cmp.end(), fcmp);

            vector<int> curr;
            pair<int, int> last = {-1, -1};
            for(int x: cmp)
            {
                if(make_pair(V[x], gr[x]) != last)
                {
                    if(!curr.empty()) answer.push_back(curr);
                    curr.clear();
                }

                curr.push_back(x);
                last = {V[x], gr[x]};
            }

            answer.push_back(curr);
        }*/

    cout << answer.size() << endl;
    for(auto it: answer)
    {
        cout << it.size() << " ";
        for(int x: it) cout << x << " ";
        cout << endl;
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    read();
    solve();
    return 0;
}

/**
12 2
6 1 2 3 10 4 5
6 7 8 9 12 6 11
4 5 6 7 8 9 2 1 3 11 12 3

**/
