#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int N = 100007;
const int SZ = 4007;

struct cmp_first {
    bool operator () (const pair < int, int > &a, const pair < int, int > &b) const {
        return a.first==b.first ? a.second<b.second : a.first<b.first;
    }
};

struct cmp_second {
    bool operator () (const pair < int, int > &a, const pair < int, int > &b) const {
        return a.second==b.second ? a.first<b.first : a.second<b.second;
    }
};

struct cmp_dist {
    bool operator () (const pair < int, int > &a, const pair < int, int > &b) const {
        return a.first*1ll*a.first+a.second*1ll*a.second<b.first*1ll*b.first+b.second*1ll*b.second;
    }
};

struct cmp_sum {
    bool operator () (const pair < int, int > &a, const pair < int, int > &b) const {
        return a.first+a.second<b.first+b.second;
    }
};

int n,m,sz1,sz2;
pair < int, int > a[N],b[N],arr1[SZ],arr2[SZ];
long long ans;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int i,j;

    scanf("%d %d", &n, &m);
    for(i=1;i<=n;i++) {
        scanf("%d %d", &a[i].first, &a[i].second);
    }

    for(i=1;i<=m;i++) {
        scanf("%d %d", &b[i].first, &b[i].second);
    }

    /*sort(a+1,a+1+n,cmp_first());
    sort(b+1,b+1+m,cmp_first());

    for(i=1;i<=n && i<=1000;i++) {
        arr1[++sz1]=a[i];
    }
    for(i=m;i>=m-1000 && i>=1;i--) {
        arr2[++sz2]=b[i];
    }

    sort(a+1,a+1+n,cmp_second());
    sort(b+1,b+1+m,cmp_second());

    for(i=1;i<=n && i<=1000;i++) {
        arr1[++sz1]=a[i];
    }
    for(i=m;i>=m-1000 && i>=1;i--) {
        arr2[++sz2]=b[i];
    }*/

    sort(a+1,a+1+n,cmp_dist());
    sort(b+1,b+1+m,cmp_dist());

    for(i=1;i<=n && i<=2000;i++) {
        arr1[++sz1]=a[i];
    }
    for(i=m;i>=m-2000 && i>=1;i--) {
        arr2[++sz2]=b[i];
    }

    sort(a+1,a+1+n,cmp_sum());
    sort(b+1,b+1+m,cmp_sum());

    for(i=1;i<=n && i<=2000;i++) {
        arr1[++sz1]=a[i];
    }
    for(i=m;i>=m-2000 && i>=1;i--) {
        arr2[++sz2]=b[i];
    }


    for(i=1;i<=sz1;i++) {
        for(j=1;j<=sz2;j++) {
            if(arr1[i].first<=arr2[j].first && arr1[i].second<=arr2[j].second) {
                ans=max(ans,(arr2[j].first-arr1[i].first)*1ll*(arr2[j].second-arr1[i].second));
            }
        }
    }
    
    printf("%lld\n", ans);

    return 0;
}
