#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int N = 100007;

struct cmp_a {
    bool operator () (const pair < int, int > &a, const pair < int, int > &b) const {
        return a.second==b.second ? a.first<b.first : a.second<b.second;
    }
};

struct cmp_b {
    bool operator () (const pair < int, int > &a, const pair < int, int > &b) const {
        return a.second==b.second ? a.first>b.first : a.second>b.second;
    }
};

int n,m;
pair < int, int > a[N],b[N],tmp[N];
int tmp_sz;
long long ans;

long long area(pair < int, int > a, pair < int, int > b) {
    return (a.first-b.first)*1ll*(a.second-b.second);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int i,j;

    scanf("%d %d", &n, &m);

    for(i=1;i<=n;i++) {
        scanf("%d %d", &a[i].first, &a[i].second);
    }

    for(i=1;i<=m;i++) {
        scanf("%d %d", &b[i].first, &b[i].second);
    }

    sort(a+1,a+1+n,cmp_a());

    tmp[++tmp_sz]=a[1];
    
    for(i=2;i<=n;i++) {
        if(a[i].second>tmp[tmp_sz].second && a[i].first<tmp[tmp_sz].first) {
            tmp[++tmp_sz]=a[i];
        }
    }

    n=tmp_sz;
    for(i=1;i<=n;i++) {
        a[i]=tmp[i];
    }

    sort(b+1,b+1+m,cmp_b());

    tmp_sz=0;
    tmp[++tmp_sz]=b[1];
    for(i=2;i<=m;i++) {
        if(b[i].second<tmp[tmp_sz].second && b[i].first>tmp[tmp_sz].first) {
            tmp[++tmp_sz]=b[i];
        }
    }

    m=tmp_sz;
    for(i=1;i<=m;i++) {
        b[i]=tmp[i];
    }

    /*printf("new a:\n");
    for(i=1;i<=n;i++) printf("%d %d\n", a[i].first, a[i].second);
    printf("new b:\n");
    for(i=1;i<=m;i++) printf("%d %d\n", b[i].first, b[i].second);
    */

    for(i=1;i<=n;i++) {
        for(j=max(i-50,1);j<=min(m,i+50);j++) {
            ans=max(ans,area(a[i],b[j]));
        }
    }

    reverse(b+1,b+1+m);
    for(i=1;i<=n;i++) {
        for(j=max(i-50,1);j<=min(m,i+50);j++) {
            ans=max(ans,area(a[i],b[j]));
        }
    }

    printf("%lld\n", ans);

    return 0;
}
