#include <bits/stdc++.h>
#define endl '\n'
#define x first
#define y second

using namespace std;

const int N = 100007;

struct cmp_a {
    bool operator () (const pair < int, int > &a, const pair < int, int > &b) const {
        return a.second==b.second ? a.first<b.first : a.second<b.second;
    }
};

struct cmp_b {
    bool operator () (const pair < int, int > &a, const pair < int, int > &b) const {
        return a.second==b.second ? a.first>b.first : a.second>b.second;
    }
};

int n,m;
pair < int, int > a[N],b[N],tmp[N];
int tmp_sz;
long long ans;

long long area(pair < int, int > a, pair < int, int > b) {
    return (a.first-b.first)*1ll*(a.second-b.second);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int i,j,z;

    scanf("%d %d", &n, &m);

    for(i=1;i<=n;i++) {
        scanf("%d %d", &a[i].first, &a[i].second);
    }

    for(i=1;i<=m;i++) {
        scanf("%d %d", &b[i].first, &b[i].second);
    }

    sort(a+1,a+1+n,cmp_a());

    tmp[++tmp_sz]=a[1];
    
    for(i=2;i<=n;i++) {
        if(a[i].second>tmp[tmp_sz].second && a[i].first<tmp[tmp_sz].first) {
            tmp[++tmp_sz]=a[i];
        }
    }

    n=tmp_sz;
    for(i=1;i<=n;i++) {
        a[i]=tmp[i];
    }

    sort(b+1,b+1+m,cmp_b());

    tmp_sz=0;
    tmp[++tmp_sz]=b[1];
    for(i=2;i<=m;i++) {
        if(b[i].second<tmp[tmp_sz].second && b[i].first>tmp[tmp_sz].first) {
            tmp[++tmp_sz]=b[i];
        }
    }

    m=tmp_sz;
    for(i=1;i<=m;i++) {
        b[i]=tmp[i];
    }

    /*printf("new a:\n");
    for(i=1;i<=n;i++) printf("%d %d\n", a[i].first, a[i].second);

    
    printf("new m:\n");
    for(i=1;i<=m;i++) printf("%d %d\n", b[i].first, b[j].second);
    */

    i=1;
    while(i<=n && a[i].x>b[1].x) ++i;
    for(j=1;j<=m && i<=n && a[i].y<=b[j].y;j++) {
        while(i+1<=n && a[i+1].y<=b[j].y && area(a[i+1],b[j])>=area(a[i],b[j])) ++i;
        if(a[i].y>b[j].y) break;
        //printf("For j = %d, we got i = %d\n", j, i);
        for(z=i-10;z<=i+10;z++) if(z>=1 && z<=n) if(a[z].first<b[j].first && a[z].second<b[j].second) {
            ans=max(ans,area(a[z],b[j]));
        }
    }

    i=n;
    while(i>=1 && a[i].y>=b[1].y) --i;
    for(j=1;j<=m && i>=1 && a[i].x<=b[j].x;j++) {
        while(i-1>=1 && a[i-1].x<=b[j].x && area(a[i-1],b[j])>=area(a[i],b[j])) --i;
        if(a[i].x>b[j].x) break;
        for(z=i-10;z<=i+10;z++) if(z>=1 && z<=n) if(a[z].first<b[j].first && a[z].second<b[j].second) {
            ans=max(ans,area(a[z],b[j]));
        }
    }

    printf("%lld\n", ans);

    return 0;
}
