#include<iostream>
#include<stack>
#include<utility>
using namespace std;
const int MAXN=105;
char pole[105][105];
bool checkHor(int row,int from,int to){
	for(int i=from;i<=to;i++){
		if(pole[row][i]=='/'||pole[row][i]=='-') continue;
		return false;
	}
	return true;
}
bool checkVer(int col,int from,int to){
	for(int i=from;i<=to;i++){
		if(pole[i][col]=='/'||pole[i][col]=='|') continue;
		return false;
	}
	return true;
}
void fixate(int i,int j,int p,int q){
	for(int x=j;x<=j+q;x++){
		pole[i][x]='/';
		pole[i+p][x]='/';
	}
	for(int x=i;x<=i+p;x++){
		pole[x][j]='/';
		pole[x][j+q]='/';
	}
}
stack<pair<int,int>> up,down; 
bool checkRect(int i,int j,int p,int q){
	if((pole[i][j]=='1'||pole[i][j]=='/')&&
	   (pole[i][j+q]=='2'||pole[i][j+q]=='/')&&
	   (pole[i+p][j+q]=='3'||pole[i+p][j+q]=='/')&&
	   (pole[i+p][j]=='4'||pole[i+p][j]=='/')){
		if(checkHor(i,j+1,j+q-1)&&checkHor(i+p,j+1,j+q-1)&&checkVer(j,i+1,i+p-1)&&checkVer(j+q,i+1,i+p-1)){
			up.push({i,j});
			down.push({i+p,q+j});
			fixate(i,j,p,q);
			return true;
		}
	}
	return false;
}
int main(){
	cin.tie(NULL);
	ios::sync_with_stdio(false);
	int n,m;
	cin>>n>>m;
	for(int i=0;i<n;i++){
		for(int j=0;j<m;j++){
			cin>>pole[i][j];
		}
	}
	for(int i=0;i<n;i++){
		for(int j=0;j<m;j++){
			if(pole[i][j]=='1'){
				for(int p=1;i+p<n;p++){
					for(int q=1;j+q<m;q++){
						if(checkRect(i,j,p,q)){
							q=1<<30;
							p=1<<30;
							j=m;
							i=-1;
						}
					}
				}
			}
		}
	}
	for(int i=0;i<n;i++){
		for(int j=0;j<m;j++){
			if(pole[i][j]=='2'){
				for(int p=1;i+p<n;p++){
					for(int q=1;j-q>=0;q++){
						if(checkRect(i,j-q,p,q)){
							q=1<<30;
							p=1<<30;
							j=m;
							i=-1;
						}
					}
				}
			}
		}
	}
	for(int i=0;i<n;i++){
		for(int j=0;j<m;j++){
			if(pole[i][j]=='3'){
				for(int p=1;i-p>=0;p++){
					for(int q=1;j-q>=0;q++){
						if(checkRect(i-p,j-q,p,q)){
							q=1<<30;
							p=1<<30;
							j=m;
							i=-1;
						}
					}
				}
			}
		}
	}
	for(int i=0;i<n;i++){
		for(int j=0;j<m;j++){
			if(pole[i][j]=='4'){
				for(int p=1;i-p>=0;p++){
					for(int q=1;j+q<m;q++){
						if(checkRect(i-p,j,p,q)){
							q=1<<30;
							p=1<<30;
							j=m;
							i=-1;
						}
					}
				}
			}
		}
	}
	cout<<up.size()<<"\n";
	while(!up.empty()){
		cout<<up.top().first<<" "<<up.top().second<<" "<<down.top().first<<" "<<down.top().second<<"\n";
		up.pop();
		down.pop();
	}
	return 0;
}
