#include<iostream>
#include<vector>
using namespace std;
const int MAXN=105;
char pole[105][105];
int cell[105][105];
bool checkHor(int row,int from,int to){
	for(int i=from;i<=to;i++){
		if(pole[row][i]=='/'||pole[row][i]=='-') continue;
		return false;
	}
	return true;
}
bool checkVer(int col,int from,int to){
	for(int i=from;i<=to;i++){
		if(pole[i][col]=='/'||pole[i][col]=='|') continue;
		return false;
	}
	return true;
}
vector<pair<int,int>> up,down; 
//int cnt;
void fixate(int i,int j,int p,int q){
	for(int x=j;x<=j+q;x++){
		pole[i][x]='/';
		pole[i+p][x]='/';
		//cell[i][x]=cnt;
		//cell[i+p][x]=cnt;
	}
	for(int x=i;x<=i+p;x++){
		pole[x][j]='/';
		pole[x][j+q]='/';
		//cell[x][j]=cnt;
		//cell[x][j+q]=cnt;
	}
}
bool checkRect(int i,int j,int p,int q){
	if((pole[i][j]=='1'||pole[i][j]=='/')&&
	   (pole[i][j+q]=='2'||pole[i][j+q]=='/')&&
	   (pole[i+p][j+q]=='3'||pole[i+p][j+q]=='/')&&
	   (pole[i+p][j]=='4'||pole[i+p][j]=='/')){
		if(checkHor(i,j+1,j+q-1)&&checkHor(i+p,j+1,j+q-1)&&checkVer(j,i+1,i+p-1)&&checkVer(j+q,i+1,i+p-1)){
			up.push_back({i,j});
			down.push_back({i+p,q+j});
			//cnt++;
			fixate(i,j,p,q);
			return true;
		}
	}
	return false;
}
int main(){
	cin.tie(NULL);
	ios::sync_with_stdio(false);
	int n,m;
	cin>>n>>m;
	for(int i=0;i<n;i++){
		for(int j=0;j<m;j++){
			cin>>pole[i][j];
		}
	}
	for(int i=n-1;i>=0;i--){
		for(int j=m-1;j>=0;j--){
			if(pole[i][j]=='1'){
				for(int p=1;i+p<n;p++){
					for(int q=1;j+q<m;q++){
						checkRect(i,j,p,q);
						p=1<<30;
						q=1<<30;
					}
				}
			}
		}
	}
	for(int i=n-1;i>=0;i--){
		for(int j=0;j<m;j++){
			if(pole[i][j]=='2'){
				for(int p=1;i+p<n;p++){
					for(int q=1;j-q>=0;q++){
						checkRect(i,j-q,p,q);
						p=1<<30;
						q=1<<30;
					}
				}
			}
		}
	}
	for(int i=0;i<n;i++){
		for(int j=0;j<m;j++){
			if(pole[i][j]=='3'){
				for(int p=1;i-p>=0;p++){
					for(int q=1;j-q>=0;q++){
						checkRect(i-p,j-q,p,q);
						p=1<<30;
						q=1<<30;
					}
				}
			}
		}
	}
	for(int i=0;i<n;i++){
		for(int j=m-1;j>=0;j--){
			if(pole[i][j]=='4'){
				for(int p=1;i-p>=0;p++){
					for(int q=1;j+q<m;q++){
						checkRect(i-p,j,p,q);
						p=1<<30;
						q=1<<30;
					}
				}
			}
		}
	}
	for(int i=0;i<n;i++){
		for(int j=0;j<m;j++){
			if(pole[i][j]=='|'){
				int q=i;
				while(pole[q][j]=='|'){
					q++;
				}
				int p=j+1;
				while(pole[i][p]=='.'){
					p++;
				}
				int r=i+1;
				while(pole[r][p]=='|'||pole[r][p]=='/'){
					r++;
				}
				up.push_back({i-1,j});
				down.push_back({r-1,p});
				fixate(i-1,j-1,r-i,p-j);
			}
		}
	}
	for(int i=0;i<n;i++){
		for(int j=0;j<m;j++){
			if(pole[i][j]=='-'){
				int q=j;
				while(pole[i][q]=='-'){
					q++;
				}
				int p=i+1;
				while(pole[p][j]=='.'){
					p++;
				}
				int r=j+1;
				while(pole[p][r]=='-'||pole[p][r]=='/'){
					r++;
				}
				up.push_back({i,j-1});
				down.push_back({p,r-1});
				fixate(i-1,j-1,p-i,r-j);
			}
		}
	}
	cout<<up.size()<<"\n";
	while(!up.empty()){
		cout<<up.back().first<<" "<<up.back().second<<" "<<down.back().first<<" "<<down.back().second<<"\n";
		up.pop_back();
		down.pop_back();
	}
	return 0;
}
