#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;
int n, m;
pair < int, int > a[(1<<20)], b[(1<<20)];
vector < pair < int, int > > lh, uh;
long long ans = 0;

long long getS( pair < int, int > a, pair < int , int > b ) {
    if ( a.first >= b.first || a.second >= b.second ) { return 0 ;}
    return 1LL*( b.first-a.first)*(b.second-a.second);
}

int main () {
    cin >> n >> m;
    for ( int i = 0 ; i < n ; i ++ ) {
        cin >> a[i].first >> a[i].second;
        a[i].first *= -1;
    }

    for ( int i = 0 ; i < m ; i ++ ) {
        cin >> b[i].first >> b[i].second;
        b[i].first *= -1;
    }
    sort( a, a+n );
    reverse ( a, a+n );
    sort( b, b+m );

    for ( int i = 0 ; i < n ; i ++ ) {
        if ( lh.size() == 0 || lh.back().second > a[i].second ) {
            lh.push_back( a[i] );
        }
    }

    for ( int i = 0 ; i < m ; i ++ ) {
        if ( uh.size() == 0 || uh.back().second < b[i].second ) {
            uh.push_back( b[i] );
        }
    }

    for ( int i = 0 ; i < lh.size() ; i ++ ) {
        lh[i].first *= -1;
    }
    for ( int i = 0 ; i < uh.size() ; i ++ ) {
        uh[i].first *= -1;
    }

    for ( int i = 0 ; i < lh.size() ; i ++ ) {
        for ( int j = 0 ; j < uh.size() ; j ++ ) {
            ans = max( ans, getS( lh[i], uh[j] ) );
        }
    }
    cout << ans << "\n";
    return 0;
}
/*
3 4
4 5
5 3
2 8
9 6
8 8
0 0
4 10

*/
