#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;

int to[(1<<20)], n, k;
int par[(1<<20)], inDur[(1<<20)];
int getP( int x ) { return x == par[x] ? x : par[x] = getP( par[x] ); }

vector < int > dur[(1<<20)];
vector < int > cp;

vector < pair < int, int > > hs[(1<<20)];

long long cntU[(1<<20)], base = 331, mod = 1000000007, pows[(1<<20)];
int fl[(1<<20)];
int cycLen[(1<<20)];

vector < int > in[(1<<20)];

int cntGr = 0;
vector < int > gr[(1<<20)];

void ss () {

    int d = cp.size();
    long long cHash = 0;

    for ( int i = 0 ; i < d ; i ++ ) {
        cp[i] = getP( cp[i] );

        cHash *= base;

     //   cout << cp[i] << " ----- > " << inDur[cp[i]] << "\n";
        cHash += ( inDur[ cp[i] ] +1 );
        cHash %= mod;
    }

    for ( int s = 0 ; s < d ; s ++ ) {
        hs[ inDur[ cp[s] ] ].push_back( make_pair( cHash, cp[s] ) );

     //   cout << s << " " << cp[s] << " : " << cHash << "\n";

        cHash = ( cHash - pows[ cp.size()-1 ]*( inDur[cp[s]]+1 )%mod + mod )*base%mod + inDur[ cp[s] ]+1;
        cHash %= mod;
    }

}

void mergeCyc ( int i1, int i2 ) {
   // cout << "merging " << i1 << " " << i2 << "\n";
    for ( ; i1 != i2 ; ) {
        i1 = to[i1];
        i1 = getP(i1);

        i2 = to[i2];
        i2 = getP(i2);

        par[i1] = i2;
    }
}


void mergeV( int i1, int i2 ) {
    int p1 = getP(i1), p2 = getP(i2);

    if( p1 == p2 ) { return; }
    par[p2] = p1;

    for ( int i = 0 ; i < in[p2].size() ; i ++ ) {
        //mergeV( in[p2][i], in[p1][0] );
        in[p1].push_back( in[p2][i] );
    }

}

int main () {
    cin >> n >> k;
    for ( int i = 0 ; i <= n ; i ++ ) { par[i] = i; }

    pows[0] = 1;
    pows[1] = base;
    for ( int i = 2 ; i <= n ; i ++ ) { pows[i] = pows[i-1]*base%mod; }

    for ( int i = 0 ; i < k ; i ++ ) {
        int l;
        cin >> l;
        for ( int j = 0 ; j < l ; j ++ ) {
            int a;
            cin >> a;
            dur[i].push_back( a );
            inDur[a] = i;
        }
    }
    for ( int i = 1 ; i <= n ; i ++ ) { cin >> to[i]; }

    for ( int i = 1 ; i <= n ; i ++ ) {
        if ( cntU[i] ) { continue; }
        int crr = i;
        for ( ; !cntU[crr];  crr = to[crr] ) {
            cp.push_back( crr );
            cntU[crr] = 1;
        }
        reverse( cp.begin(), cp.end() );
        for ( ; cp.size() && cp.back() != crr; cp.pop_back() );

      /*  cout << "Cyc: \n";
        for ( int i = 0 ; i < cp.size() ; i ++ ) {
            cout << cp[i] << " ";
        }
        cout << "\n";
    */
        if ( cp.size() ) {
            ss();
        }
        cp.clear();
    }

    for ( int h = 0 ; h < k ; h ++ ) {
        sort( hs[h].begin(), hs[h].end() ) ;
        for ( int i = 0 ; i < hs[h].size() ; ) {

            int j = i;
            for ( ; j < hs[h].size() && hs[h][i].first == hs[h][j].first ; j ++ ) {
                mergeCyc( hs[h][i].second, hs[h][j].second );
            }
            i = j;
        }
    }

    for ( int i = 1 ; i <= n ; i ++ ) {
        in[ to[ getP(i) ] ].push_back( getP(i) ) ;
    }

    for ( int cc = 0 ; cc <= n ; cc ++ ) {
        for ( int i = 1 ; i <= n ; i ++ ) {
            for ( int j = 0 ; j < in[i].size() ; j ++ ) {
                mergeV( in[i][j], in[i][0] );
            }
            while ( in[i].size() > 1 ) { in[i].pop_back(); }
        }
    }

    for ( int i = 1 ; i <= n ; i ++ ) {
        gr[ getP(i) ].push_back( i );
        if ( par[i] == i ) { cntGr ++; }
    }

    cout << cntGr << "\n";
    for ( int i = 1 ; i <= n ; i ++ ) {
        if ( gr[i].size() ) {
            cout << gr[i].size() << " ";
            for ( int j = 0 ; j < gr[i].size() ; j ++ ) {
                cout << gr[i][j] << " ";
            }
            cout << "\n";
        }
    }

    return 0;
}
/*
12 2
6 1 2 3 10 4 5
6 7 8 9 12 6 11
4 5 6 7 8 9 2 1 3 11 12 3

*/
