#include <iostream>
#include <cstring>
#include <vector>
#include <algorithm>
using namespace std;
char input[128][128];
bool used[128][128];
int n, m;

//vector < pair < int, pair < int, int > > frs;

vector < pair < int, int > > ss, ff;

int pos ( int x, int y, int len ) {

    int cnt = 0;

    if ( !used[y][x] && input[y][x] != '1' ) { return 0; }
    if ( !used[y+len-1][x] && input[y+len-1][x] != '4' ) { return 0; }
    if ( !used[y][x+len-1] && input[y][x+len-1] != '2' ) { return 0; }
    if ( !used[y+len-1][x+len-1] && input[y+len-1][x+len-1] != '3' ) { return 0; }

    if ( !used[y][x] ) { cnt++; }
    if ( !used[y+len-1][x] ) { cnt++; }
    if ( !used[y][x+len-1] ) { cnt++; }
    if ( !used[y+len-1][x+len-1] ) { cnt++; }


    for ( int nx = x+1 ; nx < x+len-1 ; nx ++ ) {
        if ( !used[y][nx] && input[y][nx] != '-' ) { return 0; }
        if ( !used[y+len-1][nx] && input[y+len-1][nx] != '-' ) { return 0; }

        if ( !used[y][nx] ) { cnt++; }
        if ( !used[y+len-1][nx] ) { cnt++; }

    }

    for ( int ny = y+1 ; ny < y+len-1 ; ny ++ ) {
        if ( !used[ny][x] && input[ny][x] != '|' ) { return 0; }
        if ( !used[ny][x+len-1] && input[ny][x+len-1] != '|' ) { return 0; }

        if ( !used[ny][x] ) { cnt++; }
        if ( !used[ny][x+len-1] ) { cnt++; }

    }
    if ( cnt == 0 ) { return 0; }
    return 1;

}
void print() {
    for ( int y= 0 ; y < n ; y ++) {
        for ( int x = 0 ; x < m ; x ++ ) {
            if ( used[y][x] ) { cout << " "; }
            else { cout << input[y][x] ; }
        }
        cout<< "\n";
    }
}
void setFr ( int x, int y, int len ) {

    ss.push_back( make_pair(y, x) );
    ff.push_back( make_pair(y+len-1, x+len-1) );

    //cout << y << " " << x << " " << y+len-1 << " " << x+len-1 << "\n";
    for ( int nx = x ; nx < x+len ; nx ++ ) {
        used[y][nx] = 1;
        used[y+len-1][nx] = 1;
    }

    for ( int ny = y ; ny < y+len ; ny ++ ) {
        used[ny][x] = 1;
        used[ny][x+len-1] = 1;
    }

}

int getCnt ( ) {
    int ret = 0;
    for ( int i = 0 ; i < n ; i ++ ) {
        for ( int j = 0 ; j< m ; j ++ ) {
            if ( !used[i][j] && input[i][j] != '.' ) { ret ++; }
        }
    }
    return ret;
}


int main () {
    cin >> n >> m;

    for ( int i = 0 ; i < n ; i ++ ) {
        cin >> input[i];
    }

    for ( ; getCnt() ; ) {
        for ( int y = 0 ; y < n ; y ++ ) {
            for ( int x = 0 ; x < m ; x ++ ) {

                for ( int len = 2 ; x + len <= min( n, m ) && y+len <= min( n, m ) ; len ++ ) {

                    if ( pos( x, y, len ) ) {
                        setFr( x, y, len );
               //         cout << x << " " << y << " " << len << "\n";
                     //   print();
                    }
                }
            }
        }
    }
    reverse( ss.begin(), ss.end() );
    reverse( ff.begin(), ff.end() );
    cout << ss.size() << "\n";
    for ( int i = 0 ; i < ss.size() ; i ++ ) {
        cout << ss[i].first << " " << ss[i].second << " " << ff[i].first << " " << ff[i].second << "\n";
    }

    //print();

}
/*

5 5
1--2.
|.1-2
|.|||
4-4-3
.....


10 10
..1-1----2
1-------2|
1----2--||
||||||..||
||||||..||
|-|-4|--|3
||||||--||
4----3--||
||4-----|3
4-------3.

*/
