#include<iostream>
#include<stdio.h>
#include<algorithm>
#include<queue>
#include<vector>
using namespace std ;

#define MAXN 200007
#define inf 1000000007

int n , m ;
struct tuhla {
    long long x , y ;
    int type ;
    int id ;
};

tuhla a[ MAXN ] ;
bool used[ MAXN ] ;

vector < tuhla > v ;

bool cmp ( tuhla p1 , tuhla p2 ) {
    if ( p1.y != p2.y ) { return ( p1.y < p2.y ) ; }
    return ( p1.x < p2.x ) ;
}

void input ( ) {
    scanf ( "%d%d" , &n , &m ) ;
    int i ;
    for ( i = 1 ; i <= n ; i ++ ) {
        scanf ( "%lld%lld" , &a[ i ].x , &a[ i ].y ) ;
        a[ i ].type = 1 ;
        a[ i ].id = i ;
    }
    for ( i = n + 1 ; i <= n + m ; i ++ ) {
        scanf ( "%lld%lld" , &a[ i ].x , &a[ i ].y ) ;
        a[ i ].type = 2 ;
        a[ i ].id = i ;
    }
    sort ( a + 1 , a + n + 1 , cmp ) ;
}

void solve ( ) {
    int i , j ;
    int mn = inf ;
    for ( i = 1 ; i <= n ; i ++ ) {
        if ( a[ i ].x >= mn ) { used[ i ] = false ; }
        else { used[ i ] = true ; }
        if ( mn > a[ i ].x ) { mn = a[ i ].x ; }
    }
    for ( i = 1 ; i <= n ; i ++ ) {
        if ( used[ i ] == true ) { v.push_back ( a[ i ] ) ; }
    }
    int sz = v.size ( ) ;
    long long ans , cur ;
    ans = 0 ;
    for ( i = n + 1 ; i <= n + m ; i ++ ) {
        for ( j = 0 ; j < sz ; j ++ ) {
            if ( v[ j ].y >= a[ i ].y ) { break ; }
            if ( v[ j ].x >= a[ i ].x || v[ j ].y >= a[ i ].y ) { continue ; }
            long long cur = 1LL * ( a[ i ].x - v[ j ].x ) * ( a[ i ].y - v[ j ].y ) ;
            if ( ans < cur ) { ans = cur ; }
        }
    }
    printf ( "%lld\n" , ans ) ;
}

int main ( ) {
    input ( ) ;
    solve ( ) ;
    return 0 ;
}

/**
3 4
4 5
5 3
2 8
9 6
8 8
0 0
4 10
**/
