# include <cstdio>
# include <vector>
# include <algorithm>

using namespace std;

const int MAX_N = 5000 + 10;
const int MAX_K = 5000 + 10;

int n, k;

vector <int> c[MAX_K];

int from[MAX_N];
int par[MAX_N];
int sz[MAX_N];

int to[MAX_N];

int in[MAX_N];
int ina[MAX_N];

int u[MAX_N], key, stkey;

int find (int x)
{
    ///printf ("%d %d\n", x, par[x]);
    return (par[x] == x) ? x : par[x] = find (par[x]);
}

int ff = 0;

bool can_add (int x, int y)
{
    ff ++;
    if (ff > 10000)
        return true;
    int rx = find (x), ry = find (y);

    if (rx == ry)
        return true;

    if (u[rx] == u[ry] && u[rx] >= stkey)
        return true;

    u[rx] = u[ry] = key ++;

    if (from[to[rx]] == from[to[ry]] && can_add (to[rx], to[ry]))
    {
        if (sz[rx] > sz[ry])
        {
            par[ry] = rx;
            sz[rx] += sz[ry];
        }
        else
        {
            par[rx] = ry;
            sz[ry] += sz[rx];
        }

        return true;
    }

    return false;
}

int main ()
{
    int i, j, t, p, q;

    scanf ("%d%d", &n, &k);

    for (i = 1; i <= k; i ++)
    {
        scanf ("%d", &p);
        c[i].resize (p);
        for (j = 0; j < p; j ++)
        {
            scanf ("%d", &c[i][j]);
            from[c[i][j]] = i;
        }
    }

    for (i = 1; i <= n; i ++)
    {
        scanf ("%d", &to[i]);
        par[i] = i;
        sz[i] = 1;
    }

    int ansc = 0;

    for (t = 1; t <= k; t ++)
    {
        for (i = 0; i < c[t].size (); i ++)
        {
            if (in[c[t][i]])
                continue;

            ansc ++;

            in[c[t][i]] = -ansc;
            ina[ansc] ++;

            for (j = i + 1; j < c[t].size (); j ++)
            {
                ff = 0;
                stkey ++;
                key = stkey;
                if (can_add (c[t][i], c[t][j]))
                {
                    in[c[t][j]] = ansc;
                    ina[ansc] ++;
                }

                stkey = key;
            }
        }
    }

    printf ("%d\n", (int) ansc);

    for (t = 1; t <= k; t ++)
    {
        for (i = 0; i < (int) c[t].size (); i ++)
        {
            if (in[c[t][i]] > 0)
                continue;
            in[c[t][i]] = -in[c[t][i]];

            printf ("%d", ina[in[c[t][i]]]);

            for (j = i; j < c[t].size (); j ++)
                if (in[c[t][j]] == in[c[t][i]])
                    printf (" %d", c[t][j]);
            printf ("\n");
        }
    }

    return 0;
}

/**
12 2
6 1 2 3 10 4 5
6 7 8 9 12 6 11
4 5 6 7 8 9 2 1 3 11 12 3
**/
