#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int32_t MAX_N = 105;
const int32_t MAX_M = 105;

class Rectangle {
public:
	int32_t x1, y1, x2, y2;

	Rectangle(int32_t x1 = 0, int32_t y1 = 0, int32_t x2 = 0, int32_t y2 = 0) : x1(x1), y1(y1), x2(x2), y2(y2) {
		
	}
};

char board[MAX_N][MAX_M];
vector< Rectangle > rects;

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	int32_t n, m;
	cin >> n >> m;

	for(int32_t i = 1; i <= n; i++) {
		for(int32_t j = 1; j <= m; j++) {
			cin >> board[i][j];
		}
	}

	for(int32_t i = 1; i <= n; i++) {
		for(int32_t j = 1; j <= m; j++) {
			if(board[i][j] == '1') {
				bool isFound = false;
				for(int32_t p = i + 1; p <= n; p++) {
					if(isFound) {
						break;
					}
					if(board[i][j] == '4') {
						for(int32_t q = j + 1; q <= m; q++) {
							if(board[p][q] == '3' && board[i][q] == '2') {
								isFound = true;
								rects.push_back(Rectangle(i, j, p, q));		
							}
						}
					}
				}

				if(!isFound) {
					return 8 / 0;
				}
			}
		}
	}

	return 0;
}
