#include<iostream>
#include<cstdlib>
#include<cstdio>
#include<cstring>
#include<cmath>
#include<algorithm>
#include<map>
#include<set>
#include<stack>
#include<queue>
#include<vector>
using namespace std;
struct iliqn
{
    int x1,y1,x2,y2;
    iliqn() {}
    iliqn(int _x1, int _y1, int _x2, int _y2)
    {
        x1=_x1;
        y1=_y1;
        x2=_x2;
        y2=_y2;
    }
};
vector<iliqn> ans;
int used[128][128];
char c[128][128];
int n,m;
int br;
void read()
{
    cin>>n>>m;
    int i,j;
    for(i=0;i<n;i++)
    {
        for(j=0;j<m;j++)
        {
            cin>>c[i][j];
            if(c[i][j]!='.')
                br++;
        }
    }
}
int check(int x1, int y1, int x2, int y2)
{
    int L=0;
    if(c[x1][y1]!='1'&&!used[x1][y1]) return 0;
    if(c[x2][y1]!='4'&&!used[x2][y1]) return 0;
    if(c[x1][y2]!='2'&&!used[x1][y2]) return 0;
    if(c[x2][y2]!='3'&&!used[x2][y2]) return 0;
    if(!used[x1][y1]||!used[x1][y2]||!used[x2][y1]||!used[x2][y2])
        L=1;
    int i,j;
    for(i=x1+1;i<x2;i++)
    {
        if(c[i][y1]!='|'&&!used[i][y1]) return 0;
        if(c[i][y2]!='|'&&!used[i][y2]) return 0;
        if(!used[i][y1]||!used[i][y2])
            L=1;
    }
    for(i=y1+1;i<y2;i++)
    {
        if(c[x1][i]!='-'&&!used[x1][i]) return 0;
        if(c[x2][i]!='-'&&!used[x2][i]) return 0;
        if(!used[x1][i]||!used[x2][i])
            L=1;
    }
    if(!L)
        return 0;
    return 1;
}
void repair(int x1, int y1, int x2, int y2)
{
    int i,j;
    for(i=x1;i<=x2;i++)
    {
        if(!used[i][y1])
            br--;
        if(!used[i][y2])
            br--;
        used[i][y1]=used[i][y2]=1;
    }
    for(i=y1;i<=y2;i++)
    {
        if(!used[x1][i])
            br--;
        if(!used[x2][i])
            br--;
        used[x1][i]=used[x2][i]=1;
    }
}
int check_exist()
{
    return br;
}
int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	read();
    int i,j,l,k;
    int L;
    int FF=0;
    for(l=0;l<600;l++)
    {
        L=0;
        for(i=0;i<n;i++)
        {
            for(j=0;j<m;j++)
            {
                for(k=1;k+i<n,k+j<m;k++)
                {
                    if(check(i,j,i+k,j+k))
                    {
                        L=1;
                        ans.push_back(iliqn(i,j,i+k,j+k));
                        repair(i,j,i+k,j+k);
                        if(!br)
                        {
                            FF=1;
                        }
                        break;
                    }
                }
                if(FF)
                    break;
            }
            if(FF)
                break;
        }
        if(FF)
            break;
    }
    /*if(check_exist())
    {
        cout<<"duck"<<endl;
    }*/
    int sz=ans.size();
    cout<<sz<<endl;
    for(i=sz-1;i>=0;i--)
    {
        cout<<ans[i].x1<<" "<<ans[i].y1<<" "<<ans[i].x2<<" "<<ans[i].y2<<endl;
    }
	return 0;
}
/*
5 5
1--2.
|.1-2
|.|||
4-4-3
.....

10 10
..1-1----2
1-------2|
1----2--||
||||||..||
||||||..||
|-|-4|--|3
||||||--||
4----3--||
||4-----|3
4-------3.
*/
